uniform sampler2DShadow shadowMap;
uniform sampler2D Texture1;
varying vec4 projCoord;
varying vec3 Normal;

void main ()
{
	//Phong
	float NdotL;
	vec3 N, L, halbVector;
	vec4 colorPhong, diffuse, ambient, specular;
	
	//Shadow
	const float kTransparency = 0.4;
	vec4 color = texture2D(Texture1,gl_TexCoord[0].st);
	vec4 shadowColorFinal;

	gl_FragColor = color;
	
	vec3 shadowUV = projCoord.xyz / projCoord.q;
	float mapScale = 1.0 / 1024.0;

	vec4 shadowColor = shadow2D(shadowMap, shadowUV);

	shadowColor += shadow2D(shadowMap, shadowUV.xyz + vec3( mapScale,  	  0, 0));
	shadowColor += shadow2D(shadowMap, shadowUV.xyz + vec3(        0,  mapScale, 0));
	shadowColor += shadow2D(shadowMap, shadowUV.xyz + vec3(-mapScale,  mapScale, 0));
	shadowColor += shadow2D(shadowMap, shadowUV.xyz + vec3(-mapScale, -mapScale, 0));
	shadowColor += shadow2D(shadowMap, shadowUV.xyz + vec3( mapScale,  mapScale, 0));
	shadowColor += shadow2D(shadowMap, shadowUV.xyz + vec3(-mapScale,  	  0, 0));
	shadowColor += shadow2D(shadowMap, shadowUV.xyz + vec3( mapScale, -mapScale, 0));
	shadowColor += shadow2D(shadowMap, shadowUV.xyz + vec3(        0, -mapScale, 0));
	

	shadowColor = shadowColor / 9.0;

	shadowColor += kTransparency;
	shadowColor = clamp(shadowColor, 0.0, 1.0);


	if(shadowUV.x >= 0.0 && shadowUV.y >= 0.0 && shadowUV.x <= 1.0 && shadowUV.y <= 1.0 )
   	{
		shadowColorFinal = color * shadowColor;
		
		if(shadowColor.x==1 && shadowColor.y==1 && shadowColor.z==1)
		{
			N = normalize(Normal);
			for(int i=0; i<3; i++){
				L = normalize(vec3(gl_LightSource[i].position));
				halbVector = normalize(gl_LightSource[i].halfVector.xyz);
				
				NdotL = max(dot(N,L),0.0);


				ambient = gl_FrontMaterial.ambient * gl_LightSource[i].ambient;
				ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;
				
				diffuse = gl_FrontMaterial.diffuse * gl_LightSource[i].diffuse * NdotL;
				
				specular = gl_LightSource[i].specular * gl_FrontMaterial.specular * pow(max(dot(N, halbVector),0.0), gl_FrontMaterial.shininess);
				
				
				shadowColorFinal += ambient + diffuse + specular;
			}
		}
		gl_FragColor =shadowColorFinal;
	}
	else
	{
		shadowColorFinal = color;
		N = normalize(Normal);
			for(int i=0; i<3; i++){
				L = normalize(vec3(gl_LightSource[i].position));
				halbVector = normalize(gl_LightSource[i].halfVector.xyz);
				
				NdotL = max(dot(N,L),0.0);


				ambient = gl_FrontMaterial.ambient * gl_LightSource[i].ambient;
				ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;
				
				diffuse = gl_FrontMaterial.diffuse * gl_LightSource[i].diffuse * NdotL;
				
				specular = gl_LightSource[i].specular * gl_FrontMaterial.specular * pow(max(dot(N, halbVector),0.0), gl_FrontMaterial.shininess);
				
				
				shadowColorFinal += ambient + diffuse + specular;
			}
		gl_FragColor =shadowColorFinal;
	}
}

